<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Danh sách người dùng đăng ký</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="users.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Danh sách Users</p>
                </a>
              </li>
            </ul>
          </li>          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper bg-light p-3">
    <!-- Breadcrumb -->
    <div class="container-fluid">
        <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="#">Trang chủ</a></li>
        <li class="breadcrumb-item active">Danh sách người dùng</li>
        </ol>
    </div>
    <!-- /.breadcrumb -->
    <!-- Vùng header -->
    <div class="jumbotron bg-light">
      <h2 class="container">Danh sách người dùng đăng ký</h2>
    </div>
    <!-- Users DataTable -->
    <div class="container bg-light">
        <button id="btn-add-user" class="btn btn-success mb-4">Thêm User</button>
        <table class="table table-bordered table-striped table-hover" id="table-users" >
            <thead >
                <tr>
                    <th>ID</th>
                    <th>First Name</th>
                    <th>Last Name</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>

    <!-- Vùng Modal -->
    
    <!-- Modal Create -->
    <div>
        <div id="create-modal" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Create new user</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-create-firstname">First Name</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-create-firstname" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-create-lastname">Last Name</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-create-lastname" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-create-subject">Subject</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-create-subject" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Country</label>
                            </div>
                            <div class="col-sm-8">
                                <select id="select-create-country" class="form-control">
                                    <option value=""></option>
                                    <option value="VN">Việt Nam</option>
                                    <option value="USA">USA</option>
                                    <option value="AUS">Australia</option>
                                    <option value="CAN">Canada</option>
                                </select>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                    <button class="btn btn-primary" id="btn-create">Create User</button>
                </div>
            </div>
          </div>
        </div>
    </div>

    <!-- Modal Update -->
    <div>
        <div id="update-modal" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Update user</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-update-firstname">First Name</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-update-firstname" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-update-lastname">Last Name</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-update-lastname" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label for="input-update-subject">Subject</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="input-update-subject" class="form-control">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Country</label>
                            </div>
                            <div class="col-sm-8">
                                <select id="select-update-country" class="form-control">
                                    <option value=""></option>
                                    <option value="VN">Việt Nam</option>
                                    <option value="USA">USA</option>
                                    <option value="AUS">Australia</option>
                                    <option value="CAN">Canada</option>
                                </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Customer Type</label>
                            </div>
                            <div class="col-sm-8">
                                <select id="select-update-customertype" class="form-control">
                                    <option value=""></option>
                                    <option value="Standard">Standard</option>
                                    <option value="Gold">Gold</option>
                                    <option value="Premium">Premium</option>
                                </select>
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Register Status</label>
                            </div>
                            <div class="col-sm-8">
                                <select id="select-update-registerstatus" class="form-control">
                                    <option value=""></option>
                                    <option value="Accepted">Accepted</option>
                                    <option value="Denied">Denied</option>
                                    <option value="Standard">Standard</option>
                                    <option value="Gold">Gold</option>
                                </select>
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
                    <button class="btn btn-primary" id="btn-update">Update User</button>
                </div>
            </div>
          </div>
        </div>
    </div>

    <!-- Modal Delete -->
    <div>
        <div id="delete-confirm-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Delete Confirmation</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <label>Bạn có chắc chắn muốn xóa user này không?</label>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
                        <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    </section>

    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
  </footer>

</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>

​<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // biến lưu url gọi api
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    // biến lưu dữ liệu người dùng
    var gUsersList = [];
    // biến track userId để chỉnh sửa và xoá người dùng
    var gCurrentUserId = "";
    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gUSER_COLS = [ "id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action" ];
    
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gUSER_COLS_ID = 0;
    const gUSER_COLS_FIRSTNAME = 1;
    const gUSER_COLS_LASTNAME = 2;
    const gUSER_COLS_COUNTRY = 3;
    const gUSER_COLS_SUBJECT = 4;
    const gUSER_COLS_CUSTOMERTYPE = 5;
    const gUSER_COLS_REGISTERSTATUS = 6;
    const gUSER_COLS_ACTION = 7;

    var gTableUsers = $("#table-users").DataTable({
        columns: [
        {   data: gUSER_COLS[gUSER_COLS_ID] },
        {   data: gUSER_COLS[gUSER_COLS_FIRSTNAME] },
        {   data: gUSER_COLS[gUSER_COLS_LASTNAME] },
        {   data: gUSER_COLS[gUSER_COLS_COUNTRY] },
        {   data: gUSER_COLS[gUSER_COLS_SUBJECT] },
        {   data: gUSER_COLS[gUSER_COLS_CUSTOMERTYPE] },
        {   data: gUSER_COLS[gUSER_COLS_REGISTERSTATUS] },
        {   data: gUSER_COLS[gUSER_COLS_ACTION] ,
            defaultContent: `
            <div class="btn-group" role="group">
                <button class="btn btn-info edit-user">Sửa</button>
                <button class="btn btn-danger delete-user">Xoá</button>
            </div>
            `}
        ]
    })

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    // khi page load
    $(function() {
        displayAllUsers();

        $("#btn-add-user").click(function() {
            $("#create-modal").modal("show");
        });
        $("#btn-create").click(onBtnCreateUserClick);
        $("#btn-create-cancel").click(resetModalCreate);

        // gán sự kiện khi click vào cho tất cả các thành phần có class edit user trong table user
        $("#table-users").on("click", ".edit-user", function(){
            onBtnEditClick($(this));
        });
        $("#btn-update").click(onBtnUpdateUserClick);
        $("#btn-update-cancel").click(resetModalUpdate);

        $("#table-users").on("click", ".delete-user", function(){
            onBtnDeleteClick($(this));
        });
        $("#btn-confirm-delete-user").click(onBtnConfirmDeleteUserClick);
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnUpdateUserClick() {
        // thu thập dữ liệu
        var vEditUserObj = {
            firstname : "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
            registerStatus: ""
        };
        getEditUserData(vEditUserObj);

        // kiểm tra dữ liệu
        let vDataIsValid = validateUserData(vEditUserObj);
        if(vDataIsValid == true) {
            // update user nếu dữ liệu ok
            updateUser(vEditUserObj);
            resetModalUpdate();
        }
    }

    function onBtnCreateUserClick() {
        // thu thập dữ liệu
        var vNewUserObj = {
            firstname : "",
            lastname: "",
            subject: "",
            country: "",
        };
        getNewUserData(vNewUserObj);

        // kiểm tra dữ liệu
        let vDataIsValid = validateUserData(vNewUserObj);
        if(vDataIsValid == true) {
            // tạo user nếu dữ liệu ok
            createUser(vNewUserObj);
        }
    }

    // 
    function onBtnEditClick(paramButton) {
        var vThisRow = paramButton.closest("tr");
        var vRowData = gTableUsers.row(vThisRow).data();
        gCurrentUserId = getUserIdFromButton(paramButton)

        $("#input-update-firstname").val(vRowData.firstname);
        $("#input-update-lastname").val(vRowData.lastname);
        $("#input-update-subject").val(vRowData.subject);
        $("#select-update-country").val(vRowData.country);
        $("#select-update-customertype").val(vRowData.customerType);
        $("#select-update-registerstatus").val(vRowData.registerStatus);

        $("#update-modal").modal("show");
    }

    function onBtnDeleteClick(paramButton) {
        gCurrentUserId = getUserIdFromButton(paramButton);
        $("#delete-confirm-modal").modal("show");
    }

    function onBtnConfirmDeleteUserClick() {
        deleteUser();
        $("#delete-confirm-modal").modal("hide");
    }
    /*** REGION 4 - Common functions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    
    // hiển thị toàn bộ user
    function displayAllUsers() {
        // request all users
        $.ajax({
            url: gBASE_URL,
            dataType: "JSON",
            async: false,
            type: "GET",
            success: function(allUsers) {
                // lưu phản hồi vào biến toàn cục và hiển thị
                gUsersList = allUsers;
                displayUsers(gUsersList);
            },
            error: function() {
                alert("add fail");
            }
        })
    }

    // tạo mới user
    function createUser(paramUserObj) {
        // request tạo user
        console.log(JSON.stringify(paramUserObj));
        $.ajax({
            url: gBASE_URL,
            type: "POST",
            data: JSON.stringify(paramUserObj),
            dataType: "json",
            contentType: "application/json;charset=UTF-8",
            success: function() {
                // xử lí hiển thị
                alert("Tạo user mới thành công");
                resetModalCreate();
                displayAllUsers();
            },
            error: function() {
                alert("Tạo user mới thất bại")
            }
        })
    }
    // update user
    function updateUser(paramUserObj) {
        // request sửa user
        console.log(JSON.stringify(paramUserObj));
        $.ajax({
            url: gBASE_URL + gCurrentUserId,
            type: "PUT",
            data: JSON.stringify(paramUserObj),
            dataType: "json",
            contentType: "application/json;charset=UTF-8",
            success: function() {
                // xử lí hiển thị
                alert("Sửa user thành công");
                displayAllUsers();
            },
            error: function() {
                alert("Sửa user thất bại")
            }
        })
    }
    function deleteUser() {
        // request delete user
        $.ajax({
            url: gBASE_URL + gCurrentUserId,
            type: "DELETE",
            success: function() {
                // xử lí hiển thị
                alert("Delete user thành công");
                displayAllUsers();
            },
            error: function() {
                alert("Delete user thất bại")
            }
        })
    }

    // hiển thị users trong param danh sách
    function displayUsers(paramUserList) {
        gTableUsers.clear();
        gTableUsers.rows.add(paramUserList);
        gTableUsers.draw( false );
    }
    // xoá trắng và đóng modal create
    function resetModalCreate() {
        $("#create-modal").modal("hide");
        $("#create-modal input").val("");
    }

    function resetModalUpdate() {
        $("#update-modal").modal("hide");
    }
    // hiển thị id của user cùng dòng nút được ấn
    function getUserIdFromButton(paramButton) {
        var vThisRow = paramButton.closest("tr");
        var vRowData = gTableUsers.row(vThisRow).data();
        return vRowData.id;
    }

    
    // thu thập dữ liệu trong modal create user
    function getNewUserData(paramUserObj) {
        paramUserObj.firstname = $("#input-create-firstname").val().trim();
        paramUserObj.lastname= $("#input-create-lastname").val().trim();
        paramUserObj.subject= $("#input-create-subject").val().trim();
        paramUserObj.country= $("#select-create-country").val();
    }

    function getEditUserData(paramUserObj) {
        paramUserObj.firstname = $("#input-update-firstname").val().trim();
        paramUserObj.lastname= $("#input-update-lastname").val().trim();
        paramUserObj.subject= $("#input-update-subject").val().trim();
        paramUserObj.country= $("#select-update-country").val();
        paramUserObj.customerType= $("#select-update-customertype").val();
        paramUserObj.registerStatus= $("#select-update-registerstatus").val();
    }

    // kiểm tra dữ liệu điền
    function validateUserData(paramUserObj) {
        let vInputUserValues = Object.values(paramUserObj);
        if (vInputUserValues.includes("")) {
            alert("Không được để trống dữ liệu");
            return false;
        }
        return true;
    }   
</script>
</body>
</html>
